<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: nodeScripts/getPostgresData.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: nodeScripts/getPostgresData.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * Getter method : read data from postgres data table and send it to the web client using socket.io
 * @param {string} table postgres table
 * @param {string} columns column in postgres table
 * @param {string} request name of the socket event
 * @module f_getPostgresData_server
 */
module.exports = function(socket,table,request)
{
      /**
      * Pool of postgres clients object
      * @typedef {Object} Pool
      * @property {string} user - postgres user
      * @property {string} host - posgres host
      * @property {string} database - database name
      * @property {string} password - password
      * @property {number} port - port
      * @property {method} connect - connection method
      */

    const {Pool} = require('pg');
    
    const pool = new Pool({
        user: 'ThermBaseAlgebraic',
        host: 'db',
        database: 'ThermoBaseDataStationary',
        password: 'thermo',
        port: 5432
    });

      /**
      * @method pool_connect_then
      * @description The getter method uses a socket.io event to send data to a web client which is
      * read from a postgres table using a query. The arguments are : 
      * &lt;ol>&lt;li>request => socket.io event name of the data which is sent to the web client&lt;/li>
      * &lt;li>qrstr ='SELECT * FROM ' + 'public.' + '"'+table+'"' => SQL command&lt;/li>&lt;/ol>
      * &lt;br>
      * The "Select" query reads a complete table. There are 2 different socket.io send events :
      * &lt;ol>&lt;li>'sendTable'&lt;/li>
      * &lt;li>'sendCurve'&lt;/li>&lt;/ol>
      * &lt;br>
      * The request argument has to be equal to one of the below strings to create a reaction. 
      * Curves are collected in a collector array before they are sent to the client. 
      * Maps are sent directly to the client without any further conversions. 
      */

    pool.connect().then(client => {
      var qrstr ='SELECT * FROM ' + 'public.' + '"'+table+'"';
        return client
          .query(qrstr)
          .then(res => {
            client.release()
            if(request=='sendTable')
            {
              socket.emit(request,res.rows[0].Maps);              
            }
            else if(request=='sendCurve') {        
              var collect = [];
              for(var i=0;i&lt;res.rows.length;i++)
              {
                collect.push(res.rows[i].Curves)
              }   
              socket.emit(request,collect);  
            }
            else{
              
              socket.emit(request,res.rows[0]);  
            }            
          })
          .catch(err => {
            client.release()
            console.log(err.stack)
          })
      });
}</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
